
class Activity:
    def __init__(self):
        self.changes = {}
        self.prereqs = {}
        self.name = ""

    def isAvailable(self, player):
        for key, neededValue in self.prereqs.iteritems():
            if neededValue > player.getProperty(key):
                return False
        for key, change in self.changes.iteritems():
            if change < 0 and -change > player.getProperty(key):
                return False
        return True

    def getSortedChanges(self):
        items = self.changes.items()
        items.sort()
        return items

    def getSortedPrereqs(self):
        items = self.prereqs.items()
        items.sort()
        return items

    def __cmp__(self, other):
        return cmp(self.name, other.name)

    def __hash__(self):
        return hash(self.name)

    def __repr__(self):
        return "(name: %r, changes: %r)" % (self.name, self.changes)

