
import pygame

QUIT_STATE = {}

class Engine:
    def __init__(self, fps):
        self.fps = fps
        self.clock = pygame.time.Clock()

    def run(self, startState):
        state = startState
        while state is not QUIT_STATE:
            state = self.nextStep(state)
            self.clock.tick(self.fps)

    def nextStep(self, state):
        for e in pygame.event.get():
            if e.type == pygame.QUIT or (e.type == pygame.KEYDOWN and e.key == pygame.K_ESCAPE):
                return QUIT_STATE
            state = state.event(e) or state

        state = state.update() or state

        screen = pygame.display.get_surface()
        state.drawOn(screen)
        pygame.display.flip()
        return state

