
import pygame

OUTLINE_COLOR = (0,0,0,255)
OUTLINE_SIZE = 1

class FontPainter:
    def __init__(self, size):
        self.font = pygame.font.Font(None, size)
    def getLineH(self):
        return self.font.get_linesize()

    def renderText(self, text, color):
        if len(text) == 0:
            text = " "
        content = self.font.render(text, True, color)

        shadow = self.font.render(text, True, OUTLINE_COLOR)
        canvas = pygame.Surface((shadow.get_width() + 2*OUTLINE_SIZE, shadow.get_height() + 2*OUTLINE_SIZE), 0, shadow)
        canvas.blit(shadow, (-OUTLINE_SIZE,-OUTLINE_SIZE))
        canvas.blit(shadow, (OUTLINE_SIZE,-OUTLINE_SIZE))
        canvas.blit(shadow, (-OUTLINE_SIZE,OUTLINE_SIZE))
        canvas.blit(shadow, (OUTLINE_SIZE,OUTLINE_SIZE))
        canvas.blit(content, (0,0))
        return canvas

