
import Player

class Logic:
    def __init__(self, model):
        self.model = model
        self.player = Player.Player(model)

    def getAvailableActivities(self):
        availables = []
        for activity in self.model.getActivities():
            if activity.isAvailable(self.player):
                availables.append(activity)
        return availables

    def doActivity(self, activity):
        diffs = {}
        for key, change in activity.changes.iteritems():
            diff = self.player.applyChange(key, change)
            diffs[key] = diff
        return diffs

