
import glob
import os.path
import Activity
import Property

class Model:
    def __init__(self):
        self.activities = self.readObjects("activities/*.py", Activity.Activity)
        self.activities.sort()
        self.properties = self.readObjects("properties/*.py", Property.Property)
        self.properties.sort()

    def readObjects(self, pattern, constructor):
        objects = []
        filenames = glob.glob(pattern)
        for filename in filenames:
            object = self.readObject(filename, constructor)
            objects.append(object)
        return objects

    def readObject(self, filename, constructor):
        object = constructor()
        source = file(filename)
        env = {"object":object}
        exec source in env
        object.name = os.path.basename(filename)[:-3]
        return object

    def getActivities(self):
        return self.activities

    def getActivity(self, key):
        for activity in self.activities:
            if activity.name == key:
                return activity
        return None

    def getProperties(self):
        return self.properties

    def getProperty(self, key):
        for property in self.properties:
            if property.name == key:
                return property
        return None

