

class Player:
    def __init__(self, model):
        self.model = model
        self.properties = {}

    def getProperty(self, key):
        value = self.properties.get(key)
        if value is None:
            property = self.model.getProperty(key)
            value = property.start
        return value

    def applyChange(self, key, change):
        """ Applies change and returns the applied increment.
        """
        origValue = self.getProperty(key)
        value = origValue + change
        newValue = self.setProperty(key, value)
        return newValue - origValue

    def setProperty(self, key, value):
        property = self.model.getProperty(key)
        value = property.getValidValue(value)
        self.properties[key] = value
        return value

    def __str__(self):
        result = ""
        for property in self.model.getProperties():
            key = property.name
            result += "%s:%s," % (key, self.getProperty(key))
        return result

