#!/usr/bin/env python

import pygame
import Engine
import Model
import Logic
import logging

TITLE = "Career - The only way is up"
SCREEN_SIZE = 640, 480
FPS = 10

def init():
    pygame.init()
    pygame.display.set_caption(TITLE)
    pygame.display.set_mode(SCREEN_SIZE, 0)

def run(logic):
    import ActivitySelectionPage

    clock = pygame.time.Clock()
    startState = ActivitySelectionPage.ActivitySelectionPage(logic)
    engine = Engine.Engine(FPS)
    engine.run(startState)

def main():
    init()
    model = Model.Model()
    logic = Logic.Logic(model)
    run(logic)

if __name__ == "__main__":
    logging.root.setLevel(logging.INFO)
    main()

