
import HBox
import VBox
import WiLabel
import WiSpace
import FontPainter

TEXT_COLOR = (255,255,255,255)
NEW_LINK_COLOR = (50,50,255,255)
LINK_COLOR = (0,100,255,255)
SELECTED_COLOR = (255,255,0,255)
HEADING_COLOR = (255,200,0,255)
DISABLED_COLOR = (50,50,50,255)
DONE_COLOR = (0,255,50,255)
BG_COLOR = (0,100,100,255)
# See http://htmlhelp.com/cgi-bin/color.cgi?rgb=006464

PAINTERS = {}

def getPainter(fontSize):
    if fontSize in PAINTERS:
        return PAINTERS[fontSize]
    painter = FontPainter.FontPainter(fontSize)
    PAINTERS[fontSize] = painter
    return painter

NORMAL_FONT = getPainter(32)


def createTable(rows):
    table = HBox.HBox()
    if len(rows) > 0:
        columnCount = len(rows[0])
        columns = [VBox.VBox() for x in range(columnCount)]

        for row in rows:
            for column, value in zip(columns, row):
                column.addWidget(WiLabel.WiLabel(value))

        for index, column in enumerate(columns):
            if index > 0:
                table.addWidget(WiSpace.WiSpace(10,0))
            table.addWidget(column)
    return table


def createHeading(text):
    return WiLabel.WiLabel(text, getPainter(64), HEADING_COLOR)


